using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using SharpCharts.Base.Data;
using SharpCharts.Base.Order;
using System.Xml.Serialization;
using System.Windows.Media;
using SharpCharts.Base.ChartObject;
using SharpCharts.Base.Common;

namespace SharpCharts.Base.SharpScript
{
    public class ORBreakout : Strategy
    {
    	double high = double.MinValue;
    	double low = double.MaxValue;
    
        public ORBreakout()
        {
            
        }


        protected override void OnStateChange()
        {
            
            switch (base.State)
            {
                case State.Finalize:
                    break;
                case State.Initialize:
                	this.EntryHandling = EntryHandling.UniqueEntries;
                	this.EntriesPerDirection = 1;
                	this.Quantity = 100;
                	this.CanUserModifyOrders = true;
                	
                	this.TraceOrders = true;
                	
                	SetStop(40, CalculationMode.Ticks, "entry1");
                	SetTarget(40, CalculationMode.Ticks, "entry1");
                	
                
                    break;
                case State.StartUp:
                    break;
                default:
                    break;
            }
        }

        protected override void OnBarUpdate()
        {
            IBar bar = this.Bars.GetBar(CurrentBar);
            if (bar.IsFirstBarOfSession)
            {
            	this.high = High[0];
            	this.low = Low[0];
            	return;
            }
            
            if (ToTime(Time[0]) <= 100000)
            {
            	this.high = Math.Max(this.high, High[0]);
            	this.low = Math.Min(this.low, Low[0]);
            	return;
            }
            
            if (ToTime(Time[0]) >= 150000)
            {
            	if (Position.MarketPosition != MarketPosition.Flat)
            	{
            		this.ClosePosition();
            	}
            	
            	return;
            }
            
            if (Position.MarketPosition != MarketPosition.Long && Close[0] > this.high)
            {
            	EnterLong("entry1");
            	EnterLong("entry2");
            }
            else if (Position.MarketPosition != MarketPosition.Short && Close[0] < this.low)
            {
            	EnterShort("entry1");
            	EnterShort("entry2");
            }
            
        }

		public override TemplateType TemplateType
		{
			get { return TemplateType.None; }
		}
        

    }
}